#
# spec file for package pam-modules (Version 9.3)
#
# Copyright (c) 2005 SUSE LINUX Products GmbH, Nuernberg, Germany.
# This file and all modifications and additions to the pristine
# package are under the same license as the package itself.
#
# Please submit bugfixes or comments via http://www.suse.de/feedback/
#

# norootforbuild
# neededforbuild  cracklib-devel libselinux-devel libxcrypt-devel pam-devel resmgr

BuildRequires: aaa_base acl attr bash bind-utils bison bzip2 coreutils cpio cpp cracklib cvs cyrus-sasl db devs diffutils e2fsprogs file filesystem fillup findutils flex gawk gdbm-devel glibc glibc-devel glibc-locale gpm grep groff gzip info insserv less libacl libattr libgcc libnscd libselinux libstdc++ libxcrypt libzio m4 make man mktemp module-init-tools ncurses ncurses-devel net-tools netcfg openldap2-client openssl pam pam-modules patch permissions popt procinfo procps psmisc pwdutils rcs readline sed strace syslogd sysvinit tar tcpd texinfo timezone unzip util-linux vim zlib zlib-devel autoconf automake binutils cracklib-devel gcc gdbm gettext libselinux-devel libtool libxcrypt-devel pam-devel perl resmgr rpm

Name:         pam-modules
License:      GPL, BSD
Group:        System/Libraries
Requires:     pam
Provides:     pam_devperm
%ifarch       sparc %ix86 axp ppc
Provides:     pam:/lib/security/pam_unix2.so
%endif
Obsoletes:    pam_devperm
PreReq:       %insserv_prereq
Autoreqprov:  on
Version:      9.3
Release:      4
Summary:      Additional PAM Modules
Source0:      ftp://ftp.suse.com/pub/people/kukuk/pam/pam_unix2/pam_unix2-1.26.tar.bz2
Source1:      ftp://ftp.suse.com/pub/people/kukuk/pam/pam_pwcheck/pam_pwcheck-2.11.tar.bz2
Source2:      pam_homecheck-1.4.tar.bz2
Source3:      pam_devperm-1.6.tar.bz2
Source4:      pam_chroot-0.6.tar.bz2
Source5:      pam_make-0.1.tar.bz2
Source6:      http://www.openwall.com/pam/modules/pam_passwdqc/pam_passwdqc-0.7.5.tar.bz2
Source7:      http://www.openwall.com/pam/modules/pam_userpass/pam_userpass-0.9.1.tar.bz2
Source8:      http://www.openwall.com/pam/modules/pam_mktemp/pam_mktemp-0.2.5.tar.bz2
Source9:      pam_selinux-20040414.tar.bz2
Source10:     pam_resmgr-20040129.tar.bz2
Source11:     pam_wheel-1.3.tar.bz2
Source20:     logindevperm
Source21:     unix2_chkpwd.c
Source22:     pam_pwcheck.conf.sles
Source30:     README.blowfish
Source31:     README.cracklib
Source32:     README.md5
Source41:     unix2_chkpwd.8
Source50:     dlopen.sh
Patch3:       pam_devperm-1.6.diff
Patch4:       pam_chroot-0.6.dif
Patch5:       pam_make-0.1.dif
Patch6:       pam_passwdqc-0.7.5-reentrant.diff
BuildRoot:    %{_tmppath}/%{name}-%{version}-build

%description
PAM (Pluggable Authentication Modules) is a system security tool that
allows system administrators to set authentication policies without
having to recompile programs that do authentication.

This package contains additional PAM Modules, which are necessary for a
working SuSE Linux System: pam_unix2 pam_devperm pam_pwcheck
pam_homecheck pam_chroot



%debug_package
%prep
%setup -q -c %{name} -b1 -b2 -b3 -b4 -b5 -b6 -b7 -b8 -b9 -b10 -b11
cd pam_devperm-*
%patch3
cd ../pam_chroot-*
%patch4
cd ../pam_make-*
%patch5
cd ../pam_passwdqc-*
%patch6

%build
for i in * ; do
  cd $i;
  if [ -x configure ] ; then
    OPT_FLAGS="$RPM_OPT_FLAGS"
    case $i in
	pam_selinux*)
		OPT_FLAGS="$OPT_FLAGS -fno-strict-aliasing"
	;;
    esac
    CFLAGS="$OPT_FLAGS" ./configure --libdir=/%{_lib} --mandir=%{_mandir} --enable-selinux
    make
  else
    EXTRA_FLAGS=""
    case $i in
	pam_mktemp*|pam_passwdqc*)
		EXTRA_FLAGS="-fno-strict-aliasing"
	;;
	pam_userpass*)
		EXTRA_FLAGS="-fno-strict-aliasing -Iinclude"
	;;
    esac
    make CFLAGS="$RPM_OPT_FLAGS $EXTRA_FLAGS -Wa,--noexecstack -fPIC -DHAVE_SHADOW -DLINUX_PAM"
  fi
  cd ..
done
gcc -o $RPM_BUILD_DIR/unix2_chkpwd $RPM_OPT_FLAGS %{SOURCE21} -lpam

%install
rm -rf $RPM_BUILD_ROOT
install -d -m 755 $RPM_BUILD_ROOT/etc/security
mkdir -p $RPM_BUILD_ROOT/%{_lib}/security
mkdir -p $RPM_BUILD_ROOT/sbin
install -m 755 $RPM_BUILD_DIR/unix2_chkpwd $RPM_BUILD_ROOT/sbin/
install -d -m 755 $RPM_BUILD_ROOT%{_libdir}
for i in * ; do
  cd $i;
  make DESTDIR=$RPM_BUILD_ROOT install
  cd ..
done
# create pam_unix.so hard link
ln -f $RPM_BUILD_ROOT/%{_lib}/security/pam_unix2.so $RPM_BUILD_ROOT/%{_lib}/security/pam_unix.so
# install our own logindevperm config file
install -m644 $RPM_SOURCE_DIR/logindevperm $RPM_BUILD_ROOT/etc
#
# Remove stuff we don't wish to have now:
#
rm -rf $RPM_BUILD_ROOT/usr/{include,lib}
#
# On 64bit archs, we need to move same libraries ourself:
#
if [ %_lib = lib64 ]; then
  mv $RPM_BUILD_ROOT/lib/security/* $RPM_BUILD_ROOT/%{_lib}/security/
fi
# Check for module problems.  Specifically, check that every module we just
# installed can actually be loaded by a minimal PAM-aware application.
for module in $RPM_BUILD_ROOT/%{_lib}/security/pam*.so ; do
   if ! sh $RPM_SOURCE_DIR/dlopen.sh -lpam -ldl ${module} ; then
      exit 1
   fi
done
#
# Install READMEs of PAM modules
#
DOC=$RPM_BUILD_ROOT%{_defaultdocdir}/pam
mkdir -p $DOC/modules
for i in pam_*/README ; do
  cp -fpv ${i} $DOC/modules/README.`dirname ${i}`
done
cp -fpv $RPM_SOURCE_DIR/README.{blowfish,cracklib,md5} $DOC
install $RPM_SOURCE_DIR/unix2_chkpwd.8 $RPM_BUILD_ROOT%{_mandir}/man8/
#
# On UL or SLES, we have other defaults
#
%if %sles_version >= 8
cp $RPM_SOURCE_DIR/pam_pwcheck.conf.sles $RPM_BUILD_ROOT/etc/security/pam_pwcheck.conf
%endif
# Remove default/passwd file
rm $RPM_BUILD_ROOT/etc/default/passwd
# Find lang files
%{find_lang} pam_unix2
%{find_lang} pam_wheel pam_unix2.lang

%clean
rm -rf $RPM_BUILD_ROOT

%post
%{insserv_force_if_yast boot.restore_permissions }

%postun
%insserv_cleanup

%files -f pam_unix2.lang
%defattr(-,root,root,755)
%doc %{_defaultdocdir}/pam
%attr(644,root,root) %config(noreplace) /etc/logindevperm
%attr(644,root,root) %config(noreplace) /etc/security/pam_unix2.conf
%attr(644,root,root) %config(noreplace) /etc/security/pam_pwcheck.conf
%attr(755,root,root) %config /etc/init.d/boot.restore_permissions
%attr(755,root,root) %config(noreplace) /etc/security/chroot.conf
%attr(755,root,root) /sbin/restore_devperm
%attr(2755,root,shadow) /sbin/unix2_chkpwd
%attr(755,root,root) /usr/sbin/pam_selinux_check
%attr(755,root,root) /%{_lib}/security/pam_*.so
%doc %{_mandir}/man5/logindevperm.5.gz
%doc %{_mandir}/man8/pam_*.8.gz
%doc %{_mandir}/man8/unix*_chkpwd.8.gz

%changelog -n pam-modules
* Mon Mar 21 2005 - schubi@suse.de
- added /dev/devperms into /etc/logindevperm Bug 73630
* Wed Mar 09 2005 - schubi@suse.de
- added /dev/radio /dev/lirc to /etc/logindevperm Bug 63854
* Wed Jan 12 2005 - kukuk@suse.de
- Update to pam_unix2 1.26 (fix memory leak)
- Update to pam_pwcheck 2.11 (fix memory leak)
* Mon Jan 10 2005 - kukuk@suse.de
- Update to pam_wheel 1.3 (fix memory leak)
* Mon Jan 03 2005 - kukuk@suse.de
- Update to pam_unix2 1.25 [#49269]
* Mon Sep 27 2004 - kukuk@suse.de
- Update to pam_pwcheck 2.10 (read /etc/default/passwd) [#46242]
* Mon Sep 20 2004 - kukuk@suse.de
- Update to pam_unix2 1.14 to fix [Bug #45531] partially
* Tue Sep 14 2004 - kukuk@suse.de
- Add workaround for incompatible udev behavior [Bug #45204]
* Fri Aug 20 2004 - kukuk@suse.de
- Update to pam_wheel 1.1
* Thu Aug 19 2004 - kukuk@suse.de
- Add pam_wheel 1.0 (a real reentrant version)
* Wed Aug 18 2004 - kukuk@suse.de
- Use reentrant getpw* functions in pam_passwdqc
* Tue Jul 27 2004 - kukuk@suse.de
- Update to pam_unix2-1.23 (use different crypt hashes for
  different services)
* Tue May 18 2004 - kukuk@suse.de
- Remove global nullok (services, which needs it have it local)
* Mon May 17 2004 - kukuk@suse.de
- pam_pwcheck: Fix problem that md5 and blowfish passwords will
  be truncated after 8 characters
* Mon Apr 19 2004 - kukuk@suse.de
- pam_selinux: Sync with upstream version
* Fri Mar 26 2004 - kukuk@suse.de
- pam_pwcheck: Update to 2.8 [Bug #36744]
- pam_unix2: Fix valid user checking in session handling
* Mon Mar 22 2004 - adrian@suse.de
- call dlopen.sh via sh
* Sat Mar 20 2004 - adrian@suse.de
- add /dev/pilot to logindevperm. it is needed for PalmOS devices
  connected via serial port.
* Fri Mar 19 2004 - kukuk@suse.de
- Update pam_unix2 to version 1.22 (changes for PAM test suite)
- Update pam_pwcheck to version 2.7 (fix sanity check)
* Sat Mar 13 2004 - kukuk@suse.de
- Update pam_unix2 to version 1.21 (read /etc/default/passwd)
- Update pam_pwcheck to version 2.6 (fix one more memory leak)
* Mon Mar 01 2004 - kukuk@suse.de
- Adjust pam_devperm boot script
* Mon Feb 23 2004 - kukuk@suse.de
- Fix some memory leaks
* Fri Feb 20 2004 - kukuk@suse.de
- Add pam_resmgr Module
- Don't link static against libselinux
* Mon Feb 02 2004 - kukuk@suse.de
- Update pam_selinux module
* Wed Jan 28 2004 - kukuk@suse.de
- Update pam_selinux module
* Thu Jan 15 2004 - kukuk@suse.de
- Build as user
- Add pam-devel to neededforbuild
* Tue Dec 09 2003 - ro@suse.de
- unix_chkpwd.8 removed (now in pam package)
* Mon Dec 01 2003 - kukuk@suse.de
- Update pam_mktemp, pam_passwdqc and pam_userpass
- Fix all compiler warnings
- Update pam_unix2 to 1.19 (SELinux support)
* Thu Oct 30 2003 - kukuk@suse.de
- Add check, if all PAM modules are loadable
- Update pam_passwdqc and pam_userpass
* Mon Sep 15 2003 - kukuk@suse.de
- Don't print error message for empty arguments.
* Mon Sep 08 2003 - kukuk@suse.de
- Add password hook for called modules, too, to avoid entering
  password twice in chfn/chsh.
* Mon Sep 01 2003 - kukuk@suse.de
- Fix calling arguments for dlopened pam module [Bug #29592]
* Fri Aug 29 2003 - tiwai@suse.de
- added the device files for ALSA to logindevperm.
  (they are now static files.)
* Fri Aug 29 2003 - kukuk@suse.de
- Fix call_module handling for pam_krb5 [Bug #29287]
* Wed Jul 30 2003 - kukuk@suse.de
- pam_pwcheck: Update to 2.4 (don't free global PAM data)
* Tue Jul 15 2003 - kukuk@suse.de
- pam_pwcheck: Update to 2.3
- pam_unix2: Update to 1.18 (Some fixes for krb5 support)
* Mon Jul 14 2003 - kukuk@suse.de
- pam_unix2: Update to version 1.17 (final call_modules option)
* Mon Jun 30 2003 - kukuk@suse.de
- Fix persmission of /etc/logindevperm
- Add call_module patch to pam_unix2
* Tue May 27 2003 - ro@suse.de
- added cracklib-devel to neededforbuild
* Tue May 13 2003 - kukuk@suse.de
- Add missing rc_status to collect all results [Bug #26528]
* Tue May 13 2003 - kukuk@suse.de
- Fix installation of manual pages
* Mon May 12 2003 - kukuk@suse.de
- Update pam_unix2 and pam_pwcheck (allow password expiration of
  root account)
- Add unix_chkpwd and unix2_chkpwd manual pages
* Tue Mar 11 2003 - kukuk@suse.de
- Add /dev/video1394 and /dev/raw1394 [Bug #25105]
* Fri Feb 21 2003 - kukuk@suse.de
- Update pam_pwcheck to 2.1 (allow blowfish passwords with more
  than 8 characters)
* Mon Feb 10 2003 - kukuk@suse.de
- Update pam_unix2 to 1.15 (abort if user press Ctrl-D)
* Thu Jan 16 2003 - kukuk@suse.de
- Add pam_mktemp and pam_userpass
* Wed Jan 15 2003 - kukuk@suse.de
- Update pam_pwcheck to 2.0 and pam_unix2 to 1.14. This allows
  root to change the password for other NIS user again. root is
  now also able to modify passwd/shadow source files for NIS on a
  NIS master server.
* Thu Dec 12 2002 - kukuk@suse.de
- Update pam_passwdqc to 0.7
- Add READMEs about blowfish, cracklib and MD5.
- Fix location of modules on lib64 architectures
* Tue Sep 17 2002 - kukuk@suse.de
- On UL1 and SLES8, make usage of cracklib default [Bug #19636]
* Sat Sep 07 2002 - kukuk@suse.de
- Provide pam_devperm
* Tue Aug 27 2002 - kukuk@suse.de
- Update to pam_unix2 1.12 (Bugfix for pam_ldap return code
  handling, manual page added)
* Mon Aug 26 2002 - kukuk@suse.de
- Add /sbin/unix2_chkpwd [Bug #18174]
* Thu Aug 15 2002 - kukuk@suse.de
- Add insserv to PreRequires
* Sat Aug 10 2002 - kukuk@suse.de
- Update pam_pwcheck to 1.9
* Thu Aug 01 2002 - kukuk@suse.de
- Update pam_passwdqc to version 0.6 (pam_passwdqc manual page
  added)
* Mon Jul 22 2002 - kukuk@suse.de
- Update to pam_unix2 1.11 (fix detection of blowfish support)
* Thu Jul 11 2002 - kukuk@suse.de
- Update to pam_pwcheck 1.8 (fix compiling with new Linux-PAM)
* Sat Jul 06 2002 - kukuk@suse.de
- Use Should-Start for boot script
* Mon May 27 2002 - kukuk@suse.de
- Update pam_devperm to 1.5 (Don't change group ids, add manual
  page, fix documentation).
* Tue May 21 2002 - kukuk@suse.de
- Add pam_passwdqc-0.5 module
* Mon May 20 2002 - kukuk@suse.de
- Update pam_unix2 (security fixes from SL 8.0 branch)
- Update pam_pwcheck (add support for remember option)
* Thu Apr 18 2002 - kukuk@suse.de
- Update pam_unix2 and pam_pwcheck (Use libxcrypt instead of
  libcrypt)
* Tue Mar 12 2002 - kukuk@suse.de
- Allow usernames starting with "_" for pam_devperm, too.
* Sat Mar 09 2002 - kukuk@suse.de
- Update pam_unix2 to allow usernames starting with "_" [Bug #14721]
* Tue Mar 05 2002 - kukuk@suse.de
- Add all usb scanner devices [Bug #14476]
- Fix path of logindevperm
* Tue Feb 05 2002 - kukuk@suse.de
- Update to pam_unix2 1.7 (fix typo in config file parser)
- Update to pam_pwcheck 1.5 (Add global config file)
* Mon Feb 04 2002 - kukuk@suse.de
- Fix boot init script [Bug #13003]
* Thu Jan 31 2002 - grimmer@suse.de
- Added /dev/toshiba and /dev/sonypi to logindevperm to make
  laptop users happy
* Fri Jan 18 2002 - kukuk@suse.de
- Update to pam_unix2 (Fix seg.fault, read config file for
  global options)
* Tue Jan 15 2002 - kukuk@suse.de
- Update to pam_pwcheck 1.4 (better debug options)
- Update to pam_unix2 1.5 (load pam_ldap if necessary)
* Wed Jan 09 2002 - kukuk@suse.de
- Update pam_unix2 to fix crypt problems
* Mon Jan 07 2002 - kukuk@suse.de
- Big update to allow blowfish crypt
- Add pam_crypt
- Add pam_make
* Thu Dec 13 2001 - kukuk@suse.de
- Add program to recover device permissions after crash [Bug #12232]
* Wed Dec 12 2001 - kukuk@suse.de
- Make lib64 ready
* Wed Nov 28 2001 - kukuk@suse.de
- Add /dev/gps to /etc/logindevperm
* Mon Nov 12 2001 - kukuk@suse.de
- Create link for pam_unix.so
* Fri Nov 09 2001 - kukuk@suse.de
- Initial version, split from pam package
